﻿
IfNotNullAndTryGet();
IfCondition();

void IfNotNullAndTryGet()
{
    var he = new Person("Anders");

    if (he?.Attr.TryGetValue("key", out var value) == true)
    {
        value.ToString();
    }
}

void IfCondition()
{
    var he = new Person("Anders");

    if (he is Person person == null)
    {
        return;
    }

    // Visual Studio 2019
    // error CS0165: Use of unassigned local variable 'person'
    Console.WriteLine(person);

    Console.WriteLine();
}

// void DoWork()
// {
//     // warning CS0168: The variable 'i' is declared but never used 
//     // int i;
// 
//     // error CS0165: Use of unassigned local variable 'i'
//     // Console.WriteLine(i);
// 
//     
// }

record Person(string Name)
{
    public Dictionary<string, string> Attr { get; } = new Dictionary<string, string>();
}

namespace System.Runtime.CompilerServices
{
    public class IsExternalInit
    {
    }
}