﻿
using System.Collections.Generic;
using System;

public class Program
{
    public static void Main(string[] args)
    {
    }

    void IfNotNullAndTryGet()
    {
        var he = new Person("Anders");

        if (he?.Attr.TryGetValue("key", out var value) == true)
        {
            value.ToString();
        }
    }

    void IfCondition()
    {
        var he = new Person("Anders");

        if (he is Person person == false)
        {
            return;
        }

        // Visual Studio 2019
        // error CS0165: Use of unassigned local variable 'person'
        // Console.WriteLine(person);

        Console.WriteLine();
    }

    // void DoWork()
    // {
    //     // warning CS0168: The variable 'i' is declared but never used 
    //     // int i;
    // 
    //     // error CS0165: Use of unassigned local variable 'i'
    //     // Console.WriteLine(i);
    // 
    //     
    // }

    public class Person
    {
        string _name;
        public Dictionary<string, string> Attr { get; } = new Dictionary<string, string>();

        public Person(string name)
        {
            _name = name;
        }
    }

}